﻿Imports ThinkGeo.MapSuite.Serialize
Imports ThinkGeo.MapSuite.Layers
Imports ThinkGeo.MapSuite.WinForms
Imports ThinkGeo.MapSuite.Shapes
Imports ThinkGeo.MapSuite.Styles
Imports ThinkGeo.MapSuite.Drawing
Imports System.Collections.ObjectModel

Public Class Test
	Private Sub Form1_Load(sender As Object, e As EventArgs) Handles Me.Load
		Dim sKmlFilename As String
		Dim sShapeFileName As String

		Serialize()
		Return


		Using oDlg As New OpenFileDialog
			With oDlg
				.Filter = "KML Files (*.kml)|*.kml"
				Dim eResult = .ShowDialog
				If eResult = DialogResult.Cancel Then
					Return
				End If
				sKmlFilename = .FileName
			End With
		End Using

		Using oDlg As New OpenFileDialog
			With oDlg
				.Filter = "Shape Files (*.shp)|*.shp"
				Dim eResult = .ShowDialog
				If eResult = DialogResult.Cancel Then
					Return
				End If
				sShapeFileName = .FileName
			End With
		End Using

		Dim oKmlLayer As New KmlFeatureLayer(sKmlFilename)
		KmlFeatureLayer.BuildIndexFile(sKmlFilename)
		Dim oProj4 As New Proj4Projection()
		oProj4.ExternalProjectionParametersString = Proj4Projection.GetEsriParametersString(102003)
		oProj4.InternalProjectionParametersString = Proj4Projection.GetEpsgParametersString(4326)
		oKmlLayer.FeatureSource.Projection = oProj4
		oKmlLayer.StylingType = KmlStylingType.EmbeddedStyling

		Dim oLayerOverlay As New LayerOverlay
		Dim oShapeFile As New ShapeFileFeatureLayer(sShapeFileName, GeoFileReadWriteMode.Read)
		oShapeFile.ZoomLevelSet.ZoomLevel01.DefaultAreaStyle = AreaStyles.CreateSimpleAreaStyle(GeoColor.SimpleColors.Transparent, GeoColor.SimpleColors.Blue, 2)
		oShapeFile.ZoomLevelSet.ZoomLevel01.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20

		oLayerOverlay.Layers.Add(oShapeFile)
		oLayerOverlay.Layers.Add(oKmlLayer)




		WinformsMap1.MapUnit = ThinkGeo.MapSuite.GeographyUnit.Meter
		WinformsMap1.Overlays.Add(oLayerOverlay)
		oKmlLayer.Open()
		oShapeFile.Open()

		Dim oMapFeatures As Collection(Of MapShape) = KmlFeatureLayer.GetAllMapShapes(sKmlFilename)
		For Each oMapFeature As MapShape In oMapFeatures
			Debug.WriteLine(oMapFeature.Feature.GetWellKnownType.ToString)
			Dim oCols = oMapFeature.Feature.ColumnValues
			For Each oKvp As KeyValuePair(Of String, String) In oCols
				Debug.WriteLine("Key = " + oKvp.Key + " Value = " + oKvp.Value)
			Next oKvp
			Exit For
		Next oMapFeature



		WinformsMap1.CurrentExtent = oShapeFile.GetBoundingBox
		WinformsMap1.Refresh()




	End Sub
	Private Sub Serialize()
		Dim sImagePath As String = "..\..\Data\SmallSilvicsLogo.jpg"
		Dim oImage As New GeoImage(sImagePath)
		Dim oMapPrinterLayer As New MapPrinterLayer
		Dim oScalelinePrinterLayer As New ScaleLinePrinterLayer(oMapPrinterLayer)
		Dim oSerializer As New GeoSerializer
		Dim sSavePath As String = "..\..\Data\ImageLayer.xml"
		Try
			oSerializer.Serialize(oScalelinePrinterLayer, sSavePath)
		Catch ex As Exception
			MessageBox.Show("Exception message: " + ex.Message, "Boom", MessageBoxButtons.OK, MessageBoxIcon.Error)
		End Try

	End Sub

End Class
